













ARFLAGS =r
CC      =%CC%
CFLAGS	=%CFLAGS%
LDFLAGS	=
MAKEARG	=CC='$(CC)' CFLAGS='$(CFLAGS)' LDFLAGS='$(LDFLAGS)' PREFIX=$(PREFIX) \
         LIBDIR='$(LIBDIR)' BINDIR='$(BINDIR)' ANSI='$(ANSI)'
MAKEC=$(MAKE) -C
MAKEX=




WALL  =-Wtraditional -Wshadow -Wid-clash-14 -Wpointer-arith \
       -Wcast-qual -Wcast-align -Wconversion -Waggregate-return \
       -Wstrict-prototypes -Wmissing-prototypes -Wredundant-decls \
       -Wnested-externs -Winline 

WALL  =-Wstrict-prototypes

CC	=gcc

CFLAGS	=$(GCCFLAG) -Wall $(WALL) -O2 -m486 -fno-strength-reduce -g






























INDAT=-o root -g root -m 644
INEXE=-o root -g root -m 755 -s
INSCR=-o root -g root -m 755


all: check_config bcc unproto copt as86 ld86  \
     library lib-bsd alt-libs elksemu







install: check_config install-bcc install-man \
     install-lib install-lib2 install-emu

install-all: install install-other



LIBARGS= CC=ncc CCFLAGS= ARFLAGS=$(ARFLAGS)


ELKSSRC= %ELKSSRC%
PREFIX=	 %PREFIX%
BINDIR=	 %BINDIR%
LIBDIR=  %LIBDIR%


export ELKSSRC


DISTBIN= $(DIST)$(BINDIR)
DISTLIB= $(DIST)$(LIBDIR)
DISTPRE= $(DIST)$(PREFIX)


OTHERS=  tests dis88 doselks bootblocks

CLEANLIST= bcc as ld unproto copt libc elksemu libbsd $(OTHERS)



bindir: $(MAKEX)
	@mkdir -p bin lib lib/i386
	@rm -f include
	@ln -s libc/include include 2>/dev/null || true






phony:

bcc: bindir
	$(MAKEC) bcc $(MAKEARG) BCCARCH='$(BCCARCH)' bcc ncc bcc-cc1
	cp -p bcc/bcc bin/Bcc
	cp -p bcc/ncc bin/ncc
	cp -p bcc/bcc-cc1 lib/bcc-cc1

unproto:  bindir
	$(MAKEC) unproto $(MAKEARG) unproto
	cp -p unproto/unproto lib/unproto

copt:  bindir
	$(MAKEC) copt $(MAKEARG) copt
	cp -p copt/copt lib/copt
	cp -p copt/rules.* lib/.

as86: bindir
	$(MAKEC) as $(MAKEARG) all
	cp -p as/as86 bin/as86
	cp -p as/as86_encap bin/as86_encap

ld86: bindir
	$(MAKEC) ld $(MAKEARG) ld86
	cp -p ld/ld86 bin/ld86

ld86r: bindir
	$(MAKEC) ld $(MAKEARG) ld86r
	cp -p ld/ld86r bin/ld86r

objdump86: bindir
	echo  A 
elksemu: bindir


	$(MAKEC) elksemu \
	CC='$(CC)' PREFIX=$(PREFIX) LIBDIR='$(LIBDIR)' BINDIR='$(BINDIR)' \
	elksemu



	cp -p elksemu/elksemu bin/elksemu


install-ln: bcc unproto copt as86 ld86 elksemu
	install -d $(DISTBIN)
	ln -fs `pwd`/bin/ncc		$(DISTBIN)/bcc
	ln -fs `pwd`/bin/as86_encap	$(DISTBIN)/as86_encap
	ln -fs `pwd`/bin/as86 		$(DISTBIN)/as86
	ln -fs `pwd`/bin/ld86 		$(DISTBIN)/ld86

	ln -fs `pwd`/bin/elksemu 	$(DIST)/lib/elksemu

	install -d $(DIST)/usr/lib
	install $(INDAT) libc/error/liberror.txt $(DIST)/usr/lib/liberror.txt

install-bcc: bcc unproto copt as86 ld86 objdump86
	install -d $(DISTBIN) $(DISTLIB) $(DISTLIB)/i86
	install $(INEXE) bin/Bcc 	$(DISTBIN)/bcc
	install $(INSCR) bin/as86_encap	$(DISTBIN)/as86_encap
	install $(INEXE) bin/as86 	$(DISTBIN)/as86
	install $(INEXE) bin/ld86 	$(DISTBIN)/ld86
	install $(INEXE) bin/objdump86 	$(DISTBIN)/objdump86
	install $(INEXE) bin/objdump86 	$(DISTBIN)/nm86
	install $(INEXE) bin/objdump86 	$(DISTBIN)/size86
	install $(INEXE) lib/bcc-cc1 	$(DISTLIB)/bcc-cc1
	install $(INEXE) lib/unproto 	$(DISTLIB)/unproto
	install $(INEXE) lib/copt 	$(DISTLIB)/copt
	install $(INDAT) lib/rules.* 	$(DISTLIB)/i86
	@test ! -f $(DISTLIB)/as86 || rm -f $(DISTLIB)/as86
	@test ! -f $(DISTLIB)/ld86 || rm -f $(DISTLIB)/ld86


install-emu: elksemu

	install -d $(DIST)/lib
	install $(INEXE) bin/elksemu 	$(DIST)/lib/elksemu


install-man:
	-$(MAKEC) man MANDIR=$(DIST)/usr/man install

install-lib: lib/lib0-done lib/lib2-done
	install -d $(DISTLIB)/i86
	$(MAKEC) libc $(LIBARGS) BCCHOME=$(DISTPRE) install_incl
	install $(INDAT) lib/crt0.o 	$(DISTLIB)/i86/crt0.o
	install $(INDAT) lib/libc.a 	$(DISTLIB)/i86/libc.a
	install $(INDAT) lib/libbsd.a	$(DISTLIB)/i86/libbsd.a
	install -d $(DIST)/usr/lib
	install $(INDAT) libc/error/liberror.txt $(DIST)/usr/lib/liberror.txt

install-lib2: lib/lib1-done
	install -d $(DISTLIB)/i86
	install $(INDAT) lib/libc_f.a	$(DISTLIB)/i86/libc_f.a
	install $(INDAT) lib/libc_s.a	$(DISTLIB)/i86/libc_s.a
	install $(INDAT) lib/libdos.a	$(DISTLIB)/i86/libdos.a


	install -d $(DISTLIB)/i386
	install $(INDAT) lib/i386/crt0.o 	$(DISTLIB)/i386/crt0.o
	install $(INDAT) lib/i386/libc.a 	$(DISTLIB)/i386/libc.a


lib/lib0-done:
	$(MAKE) -f make.fil library

lib/lib1-done:
	$(MAKE) -f make.fil alt-libs

lib/lib2-done:
	$(MAKE) -f make.fil lib-bsd

all-libs: library lib-bsd alt-libs
	@:

library: bindir
	test -f bin/ncc
	$(MAKEC) libc $(LIBARGS) PLATFORM=i86-ELKS
	cp -p libc/crt0.o libc/libc.a lib/.
	sh libcompat lib/libc.a
	@touch lib/lib0-done

lib-bsd: bindir
	test -f bin/ncc
	$(MAKEC) libbsd $(LIBARGS)
	cp -p libbsd/libbsd.a lib/libbsd.a
	sh libcompat lib/libbsd.a
	@touch lib/lib2-done




alt-libs: lib-stand lib-dos lib-386 lib-fast 

	@touch lib/lib1-done

lib-fast: bindir
	test -f bin/ncc
	$(MAKEC) libc $(LIBARGS) PLATFORM=i86-FAST
	cp -p libc/libc_f.a lib/libc_f.a
	sh libcompat lib/libc_f.a

lib-stand: bindir
	test -f bin/ncc
	$(MAKEC) libc $(LIBARGS) PLATFORM=i86-BIOS
	cp -p libc/libc_s.a lib/libc_s.a
	sh libcompat lib/libc_s.a

lib-dos: bindir
	test -f bin/ncc
	$(MAKEC) libc $(LIBARGS) PLATFORM=i86-DOS
	cp -p libc/libdos.a lib/libdos.a
	sh libcompat lib/libdos.a


lib-386: bindir
	test -f bin/ncc
	$(MAKEC) libc $(LIBARGS) PLATFORM=i386-BCC
	cp -p libc/crt3.o lib/i386/crt0.o
	cp -p libc/libc3.a lib/i386/libc.a
	sh libcompat lib/i386/libc.a






check_config: $(MAKEX)
	$(MAKEC) libc .config.dir

config: $(MAKEX)
	$(MAKEC) libc config







makec:
	echo 'cd $$1 ; shift ; make "$$@"' > makec
	chmod +x makec



install-other: phony
	@for i in $(OTHERS) ; do \
		$(MAKEC) $$i BCC=ncc DIST=$(DIST) install || exit 1 ; \
	done

other: $(OTHERS)

$(OTHERS): phony
	$(MAKEC) $@ BCC=ncc

clean:
	-@for i in $(CLEANLIST) ; do $(MAKEC) $$i $@ ; true ; done

realclean:
	-@for i in $(CLEANLIST) ; do $(MAKEC) $$i $@ ; true ; done
	rm -rf bin lib
	rm -f include
	rm -f makec
	rm -f `find $(CLEANLIST) -type l -print`


