#include "nbp.h"

char *
bputs(char *str)
{
	int c;
	char *s;

	for (s = str; c = *s++; )
		bputc(c);

	return str;
}

unsigned
bputh1(unsigned n)
{
	if ((n &= 0x0F) < 10)
		bputc(n + '0');
	else
		bputc('A' + n - 10);

	return n & 0x0F;
}

unsigned
bputh2(unsigned n)
{
	bputh1(n >> 4);
	bputh1(n);
	return n & 0xFF;
}

unsigned
bputh4(unsigned n)
{
	bputh2(n >> 8);
	bputh2(n);
	return n;
}

unsigned long
bputh8(unsigned long n)
{
	bputh4((unsigned)(n >> 16));
	bputh4((unsigned)n);
	return n;
}

unsigned
bputu16(unsigned n)
{
	if (n > 9)
		bputu16(n / 10);

	bputc('0' + n % 10);

	return n;
}

unsigned long
bputu32(unsigned long n)
{
	if (n > 9)
		bputu32(n / 10);

	bputc('0' + (int)(n % 10));

	return n;
}

t_IP
bputip(t_IP ip)
{
	bputu16(ip & 0xFF);
	bputc('.');
	bputu16((ip >> 8) & 0xFF);
	bputc('.');
	bputu16((ip >> 16) & 0xFF);
	bputc('.');
	bputu16((ip >> 24) & 0xFF);
}
