#include "nbp.h"

UINT8 *
_find_tag(UINT8 *buffer, int length, int tag, int *skip)
{
	for (;;) {
		if (*buffer == tag) {
			if (!skip)
				return buffer;

			if (!*skip)
				return buffer;

			--*skip;
			continue;
		}

		switch (*buffer) {
		case DHCP_PAD:
			if (!--length)
				return 0;

			++buffer;
			continue;

		case DHCP_END:
			return 0;
		}

		if (buffer[1] + 2 >= length)
			return 0;

		length -= buffer[1] + 2;
		buffer += buffer[1] + 2;
	}
}

UINT8 *
find_dhcp_tag(BOOTPLAYER *pktptr, int tag, int skip)
{
	t_DHCP_OVRLOAD *ovrload;
	UINT8 *dhcpptr;

	if (*(UINT32 *)pktptr->vendor.v.magic != LONGSWAP(VM_RFC1048))
		return 0;

	ovrload = _find_tag(&pktptr->vendor.d[4], 312, DHCP_OVRLOAD, 0);

	if (dhcpptr = _find_tag(&pktptr->vendor.d[4], 312, tag, &skip))
		return dhcpptr;

	if (!ovrload)
		return 0;

	if (ovrload->type & 1)
		if (dhcpptr = _find_tag(pktptr->bootfile, sizeof pktptr->bootfile, tag, &skip))
			return dhcpptr;

	if (ovrload->type & 2)
		if (dhcpptr = _find_tag(pktptr->sname, sizeof pktptr->sname, tag, &skip))
			return dhcpptr;

	return 0;
}

UINT8 *
find_pxe_tag(BOOTPLAYER *pktptr, int tag, int skip)
{
	UINT8 *dhcpptr;
	UINT8 *pxeptr;
	int taglen;
	int pxeskip;

	for (pxeskip = 0; ; ++pxeskip) {
		if (!(dhcpptr = find_dhcp_tag(pktptr, DHCP_VENDOR, pxeskip)))
			return 0;

		if (!dhcpptr[1])
			continue;

		if (pxeptr = _find_tag(&dhcpptr[2], dhcpptr[1], tag, &skip))
			return pxeptr;

		if (!skip)
			return 0;
	}
}
