#include "nbp.h"

BOOTPLAYER discover;
BOOTPLAYER dhcpack;
BOOTPLAYER proxy;
BOOTPLAYER reply;

unsigned
nbpentry(unsigned long pxeptr, unsigned long pxenvptr)
{
	UINT16 type;

	bputs("\nIntel X86PC Bootstrap, Beta-3 (build 003)\n");

	if (!pxeinit(pxeptr, pxenvptr)) {
		bputs("\nPXE-E81: !PXE structure is invalid.\n");
		return PXENV_STATUS_FAILURE;
	}

	if (!get_cached_packet(PXENV_PACKET_TYPE_DHCP_DISCOVER, &discover)) {
		bputs("\nCould not get cached DHCP Discover packet.\n");
		return PXENV_STATUS_FAILURE;
	}

	if (!get_cached_packet(PXENV_PACKET_TYPE_DHCP_ACK, &dhcpack)) {
		bputs("\nCould not get cached DHCP Ack packet.\n");
		return PXENV_STATUS_FAILURE;
	}

	if (!get_cached_packet(PXENV_PACKET_TYPE_BINL_REPLY, &proxy)) {
		bputs("\nCould not get cached Proxy packet.\n");
		return PXENV_STATUS_FAILURE;
	}

	if (!(type = do_menu()))
		return PXENV_STATUS_SUCCESS;

	switch (do_discover(type)) {
	case -2: /* error */
		return PXENV_STATUS_FAILURE;

	case -1: /* abort */
	case 0: /* not found */
		return PXENV_STATUS_SUCCESS;
	}

	if (!set_cached_packet(PXENV_PACKET_TYPE_DHCP_DISCOVER, &discover)) {
		bputs("\nCould not set cached DHCP Discover packet.\n");
		return PXENV_STATUS_FAILURE;
	}

	if (!set_cached_packet(PXENV_PACKET_TYPE_BINL_REPLY, &reply)) {
		bputs("\nCould not set cached Proxy packet.\n");
		return PXENV_STATUS_FAILURE;
	}

	do_restart();

	return PXENV_STATUS_FAILURE;
}
