#!/bin/sh

# Written by: darnok

PATH=/sbin:/usr/sbin:/bin:/usr/bin

# Read in configuration entries

. /etc/rc.conf

echo "MPEG box. v1.00. "

# BusyBox init.

ln $SYM /bin/ln /bin/cat
ln $SYM /bin/ln /bin/mkdir

mkdir /dev/inet
mkdir /var/lock
mkdir /var/run
mkdir /tmp 

[ "$VERBOSE" ] && echo "Generating BusyBox links ..."

LINKS="`cat /etc/rc.conf.bb.links`"
for f in ${LINKS}; do
	ln $SYM /bin/ln /$f
done

[ "$VERBOSE" ] && echo "Generating POSIXness links ..."
LINKS="`cat /etc/rc.conf.pn.links`"
for f in ${LINKS}; do
	ln $SYM /bin/grep /$f
done

# Set permissions

chmod 1777 /var/lock
chmod 1777 /tmp

# Mount /proc

mount -t proc /dev/proc /proc

# Do some other stuff
cat /dev/null > /var/run/utmp

# Configure serial ports.

echo -n "Configuring serial ports.... "

${SETSERIAL} -b  /dev/ttyS0 uart 16550A port 0x3F8 irq 4 ${STD_FLAGS}
${SETSERIAL} -b  /dev/ttyS1 uart 16550A port 0x2F8 irq 3 ${STD_FLAGS}

echo "done."
 
# Just make sure it works.

sync
sleep 1

# Configure modules!

echo  "Configuring modules ..."

echo  "Configuring sound ..."
echo /sbin/insmod /modules/2.2.16/misc/ad1848.o
echo /sbin/insmod /modules/2.2.16/misc/uart401.o
echo /sbin/insmod /modules/2.2.16/misc/cs4232.o io=0x540 irq=0x0A dma=0 dma2=3


echo "Configuring network ... "
/sbin/insmod /modules/2.2.16/net/eepro100.o 

echo "Configuring network for NFS ..."

/sbin/insmod /modules/2.2.16/misc/sunrpc.o
/sbin/insmod /modules/2.2.16/fs/lockd.o
/sbin/insmod /modules/2.2.16/fs/nfs.o

# urandom

echo -n "Initializing random number generator ..."

if [ -f /var/lib/random-seed ]
then
	cat /var/lib/random-seed > /var/run/random-seed
	cat /var/run/random-seed > /dev/urandom
fi

exit 0

