//  ARCaMP (AST Remote Control MP3 Player)
//  Copyright (C) 2000 Mike Redan (mike@jeke.fdns.net)
//  Parts based on: irmp3, Winamp IR functionality v1.0
//  Copyright (C) 1999, Andreas Neuhaus (andy@fasta.fh-dortmund.de)
//  Copyright (C) 2000 Jeremy Stoppelman (jstoppelm@yahoo.com)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#include <string.h>
#include <stdlib.h>
#include "stack.h"

stack initStack(void) {    
	stack t = malloc(sizeof(stackNode));   /* returns pointer to new
                                                     stackNode space */
	t->link = NULL;
	return t;
}

bool emptyStack(stack S) {
	return (S->link == NULL);
}

bool push(stack S, int dataptr) {
	stackNode *t = malloc(sizeof(stackNode));   
	if(t != NULL) {   
		
		t->data = dataptr;      
		t->link = S->link;
		S->link = t;
		return true;
	}
	else  return false;
}

int pop(stack S) {  
	stackNode *t;
	int temp;
	if (emptyStack(S))
		return 0;
	t = S->link;         /* top node in stack */
	S->link = t->link;   /* reset the top node pointer */
	temp= t->data;          /* pointer to data element */
	free(t);             /* deallocate the node */
	return temp;
}

//this feels kinda hacky, but it should work. if anyone has a better idea forward it over to me :)
void free_list (stack S)
{
	while (!(pop(S))){};
}
