//  ARCaMP (AST Remote Control MP3 Player)
//  Copyright (C) 2000 Mike Redan (mike@jeke.fdns.net)
//  Parts based on: irmp3, Winamp IR functionality v1.0
//  Copyright (C) 1999, Andreas Neuhaus (andy@fasta.fh-dortmund.de)
//  Copyright (C) 2000 Jeremy Stoppelman (jstoppelm@yahoo.com)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "defs.h"
#include <string.h>
static struct sigaction handler;

int mpg123_fdsend = 0;	// fd to send commands to mpg123
int mpg123_fdrecv = 0;	// fd to get responses from mpg123
int mpg123_active = 0;	// if mpg123 is the active player


// ***** CATCH SIGNAL OF EXITING PLAYER
void mpg123_chld (int signal)
{
	int status;
	if (waitpid(-1, &status, WNOHANG) == mpg123_pid) {
		if (DONTPLAY == 0) {
			mpg123_pid = 0;
			ExecInst(FFW_BTN);
		}	
	}
}

int playMP3 (char params[])
{
	int fd_send[2], fd_recv[2];
	const char *name = "mpg123";
	
	//	params[strlen(params)-1] = (int)NULL; // get rid on the eol character at the end of the string
	// check if player is already running
	if (mpg123_pid)
		return 0;
	params[strlen(params)-1] = (int)NULL;
	// make socketpair to communicate with player
	if (socketpair(AF_UNIX, SOCK_STREAM, 0, fd_send) < 0)
		return -1;
	if (socketpair(AF_UNIX, SOCK_STREAM, 0, fd_recv) < 0)
		return -1;
	// handle signals
	signal(SIGPIPE, SIG_IGN);
	signal(SIGCHLD, mpg123_chld);
	
	// fork child process
	mpg123_pid = fork();
	if (mpg123_pid == 0) {
		// pipe in/output through socket to parent
		dup2(fd_send[0], STDIN_FILENO);
		close(fd_send[0]);
		close(fd_send[1]);
		dup2(fd_recv[0], STDOUT_FILENO);
		dup2(fd_recv[0], STDERR_FILENO);
		close(fd_recv[0]);
		close(fd_recv[1]);
		if (execlp(name, name,  params, " &", NULL) < 0)
			return -1;
		// never reached if exec was ok
		exit(-1);
	}
	// parent continues here
	close(fd_send[0]);
	mpg123_fdsend = fd_send[1];
	close(fd_recv[0]);
	mpg123_fdrecv = fd_recv[1];
	
	// check if player is running
	//sleep(1);
	if (!mpg123_pid) {
		printf("mpg123: player process didn't start!\n");
		return -1;
	}
	return 0;
}

int volumeAdjust (char params[])
{
	const char *name[10];
	sprintf (name, "volume %s", params);
	//	printf ("volume: %s\n", name);
	system (name);
	return 0;
}
