#include "nbp.h"

UINT8 *
add_dhcp_tag(BOOTPLAYER *pktptr, int tag, int len)
{
	UINT8 *bufptr;
	int n;

	if (!(bufptr = find_dhcp_tag(pktptr, DHCP_END, 0))) {
		bufptr = &pktptr->vendor.d[312];

		while (*(bufptr - 1) == DHCP_PAD)
			--bufptr;
	}

	bufptr[0] = tag;
	bufptr[1] = len - 2;

	for (n = 2; n < len; ++n)
		bufptr[n] = DHCP_PAD;

	bufptr[len] = DHCP_END;

	return bufptr;
}

UINT8 *
add_pxe_tag(BOOTPLAYER *pktptr, int tag, int len)
{
	UINT8 *bufptr;
	int n;

	if (!(bufptr = add_dhcp_tag(pktptr, DHCP_VENDOR, len + 3)))
		return 0;

	bufptr += 2;

	bufptr[0] = tag;
	bufptr[1] = len - 2;
	bufptr[len] = PXE_END;

	return bufptr;
}
