/* nbp.h */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Things common to all bootstrap programs.
 */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* A few #defines so we can get through the rest of the PXE header files
 * that are used in both NT and Linux environments.
 */

#define __NOFAR		1	/* This is required for dev86 environment */
				/* under Linux.  */

#define __FAR
#define __CDECL
#define signed

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* This PXE header file must be first.  It has all of the typedefs that
 * are used in the rest of the header files.
 */

#include "pxe_cmn.h"

typedef UINT32 t_IP;		/* One more typedef used in the Linux */
				/* PXE header files. */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Header files common to NT and Linux build environments.
 */

#include "pxeid.h"
#include "dhcp.h"
#include "pxe.h"
#include "bootp.h"
#include "pxe_api.h"
#include "tftp_api.h"
#include "udp_api.h"
#include "undi_api.h"

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Header files used only in Linux build environment.
 */

#include "bios_io.h"
#include "misc.h"

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* External procedure declarations
 */

int pxeinit(UINT32 pxeptr, UINT32 pxenvptr);

int get_cached_packet(int pkttype, BOOTPLAYER *pktptr);

int set_cached_packet(int pkttype, BOOTPLAYER *pktptr);

UINT8 *find_pxe_tag(BOOTPLAYER *pktptr, int tag, int skip);

UINT8 *find_dhcp_tag(BOOTPLAYER *pktptr, int tag, int skip);

UINT8 *add_pxe_tag(BOOTPLAYER *pktptr, int tag, int len);

UINT8 *add_dhcp_tag(BOOTPLAYER *pktptr, int tag, int len);

int do_menu();

int do_discover(int type, int layer);

int do_restart();

int prepare_bootsect_setup(char * cmdline);

int unload_pxe();

int udpopen();

int udpclose();

int udpwrite(t_IP *ip, t_IP gw, int dport, int sport, int bufseg, int bufoff, int bufsize);

int udpread(t_IP *dip, t_IP *sip, int *dport, int *bufsize, int bufseg, int bufoff);

int tftpreadfile(UINT32 bufaddr, UINT32 *bufsize, char *fname, t_IP sip, t_IP gw, t_IP mip, int cport, int sport, int tmout, int delay);

int tftpgetfsize(UINT32 *fsize, char *fname, t_IP sip, t_IP gw);

int restarttftp(char *fname, t_IP sip, t_IP gw, t_IP mip, int cport, int sport, int tmout, int delay);

