#include "nbp.h"

int
udpopen()
{
	t_PXENV_UDP_OPEN udpopen;

	udpopen.status = PXENV_STATUS_SUCCESS;

	pxe(PXENV_UDP_OPEN, &udpopen, _SS());

	return udpopen.status;
}

int
udpclose()
{
	t_PXENV_UDP_CLOSE udpclose;

	udpclose.status = PXENV_STATUS_SUCCESS;

	pxe(PXENV_UDP_CLOSE, &udpclose, _SS());

	return udpclose.status;
}

int
udpwrite(t_IP *ip, t_IP gw, int dport, int sport, int bufseg, int bufoff, int bufsize)
{
	t_PXENV_UDP_WRITE udpwrite;

	udpwrite.status = PXENV_STATUS_SUCCESS;
	*(t_IP *)udpwrite.ip = *ip;
	*(t_IP *)udpwrite.gw = gw;
	udpwrite.src_port = intswap(sport);
	udpwrite.dst_port = intswap(dport);
	udpwrite.buffer_size = bufsize;
	udpwrite.buffer_seg = bufseg;
	udpwrite.buffer_off = bufoff;

	pxe(PXENV_UDP_WRITE, &udpwrite, _SS());

	return udpwrite.status;
}

int
udpread(t_IP *dip, t_IP *sip, int *dport, int *bufsize, int bufseg, int bufoff)
{
	t_PXENV_UDP_READ udpread;

	udpread.status = PXENV_STATUS_SUCCESS;
	*(t_IP *)udpread.dest_ip = dip ? *dip : 0;
	*(t_IP *)udpread.src_ip = sip ? *sip : 0;
	udpread.d_port = dport ? *dport : 0;
	udpread.buffer_size = *bufsize;
	udpread.buffer_off = bufoff;
	udpread.buffer_seg = bufseg;

	pxe(PXENV_UDP_READ, &udpread, _SS());

	*dip = *(t_IP *)udpread.dest_ip;
	*sip = *(t_IP *)udpread.src_ip;
	*dport = udpread.d_port;
	*bufsize = udpread.buffer_size;

	return udpread.status;
}

