#include "nbp.h"

extern t_PXE _pxe;
extern t_PXENV _pxenv;
extern int usepxe;

int
unload_pxe()
{
	t_PXENV_UNDI_SHUTDOWN shutdown;
	t_PXENV_UNLOAD_STACK unload;
	unsigned newfbms;

	/*
	 * Shutdown the UNDI.  This will stop all NIC interrupts.
	 */

	shutdown.Status = PXENV_STATUS_SUCCESS;

	if (pxe(PXENV_UNDI_SHUTDOWN, &shutdown, _SS()) != PXENV_STATUS_SUCCESS) {
		bputs("\nPXE-Exx: Cannot shutdown UNDI.\n");
		return 0;
	}

	/*
	 * Unload the base-code.
	 */

	unload.Status = PXENV_STATUS_SUCCESS;

	if (pxe(PXENV_UNLOAD_STACK, &unload, _SS()) != PXENV_STATUS_SUCCESS) {
		bputs("\nPXE-Exx: Cannot unload PXE base-code.\n");
		return 0;
	}

	/*
	 * Increase the size of free base memory.
	 */

	if (usepxe) {
		if ((newfbms = _pxe.UNDIData.Seg_Addr) > _pxe.UNDICode.Seg_Addr)
			newfbms = _pxe.UNDICode.Seg_Addr;
	} else {
		if ((newfbms = _pxenv.UNDIDataSeg) > _pxenv.UNDICodeSeg)
			newfbms = _pxenv.UNDICodeSeg;
	}

	setfbms(newfbms >> 6);


	return 1;
}
