
/*
 * Copyright Attribution.  Each Licensee Product shall display, in a 
 * user-visible location such as a start-up screen or an "About" box, 
 * and in a message to be displayed on-screen at the time Licensee 
 * Products are installed on an end-user system, the following legend, 
 * which shall be displayed for at least two (2) seconds.
 * 
 * 	"PXE Software Copyright (C) 1999  Intel Corporation"
 */

/*
 * Modifications:   $Header:   H:/archives/linux/sdk/server/include/dhcp.h.v   1.9   03 May 1999 10:55:14   mjohnsox  $
 *
 * Copyright(c) 1999 by Intel Corporation.  All Rights Reserved.
 */

#ifndef _DHCP_H
#define _DHCP_H

#define DHCP_PAD	0	/* pad character */
#define DHCP_SUBNET	1	/* subnet mask */
#define DHCP_TOFFSET	2	/* time offset */
#define DHCP_ROUTER	3	/* router option */
#define DHCP_TSRV	4	/* time server */
#define DHCP_NSRV	5	/* name server */
#define DHCP_DNSRV	6	/* domain name server */
#define DHCP_LSRV	7	/* log server */
#define DHCP_CSRV	8	/* cookie server */
#define DHCP_HNAME	12	/* hostname */
#define	DHCP_BFSIZE	13	/* Boot File Size */
#define DHCP_DNAME	15	/* domainname */
#define DHCP_VENDOR	43	/* vendor specific */
#define DHCP_NBNS	44	/* NetBIOS/WINS name server */
#define DHCP_NBDD	45	/* NetBIOS datagram distribution server */
#define DHCP_NBNODE	46	/* NetBIOS node type */
#define DHCP_NBSCOPE	47	/* NetBIOS scope */
#define DHCP_REQIP	50	/* requested IP address */
#define DHCP_LEASE	51	/* IP addr lease time */
#define DHCP_OVRLOAD	52	/* option overload */
#define DHCP_MSGTYPE	53	/* DHCP message type opcode */
	#define DHCP_DISCOVER	1	/* DHCP discover packet */
	#define DHCP_OFFER	2	/* DHCP offer packet */
	#define DHCP_REQUEST	3	/* DHCP request packet */
	#define DHCP_DECLINE	4	/* DHCP invalid config */
	#define DHCP_ACK	5	/* DHCP acknowledge packet */
	#define DHCP_NAK	6	/* DHCP negative ack packet */
	#define DHCP_RELEASE	7	/* DHCP release IP addr */
	#define DHCP_INFORM	8	/* DHCP request information */

#define DHCP_SRVID	54	/* server ID */
#define DHCP_PREQLST	55	/* parameter request list */
#define DHCP_MESSAGE	56	/* message */
#define DHCP_MAXMSG	57	/* maximum message size */
#define DHCP_CLASS	60	/* class identifier */
#define DHCP_CLIENTID	61	/* client identifier */
#define DHCP_BOOTFILE	67	/* bootfile overload */
#define DHCP_WWWSRV	72	/* web server address */

#define DHCP_SYSARCH       	93	/* system architecture */
	/* numbers assigned for system architecture types */
	#define DHCP_STD_X86		0x00
	#define DHCP_PC98_X86		0x01

#define DHCP_NICIF	   	94	/* NIC Interface specifier */
	/* numbers assigned for NIC Interface types */
	#define DHCP_UNDI		0x01  /* 2 bytes of data */
	#define DHCP_PCI		0x02  /* 12 bytes of data */
	#define DHCP_PNP		0x03  /* 7 bytes of data */

#define DHCP_PLATFORMID		97
	#define DHCP_PLATFORMID_GUID	0	/* */

#define	DHCP_END		255	/* option list terminator */

#endif /* _DHCP_H */

/* EOF - $Workfile:   dhcp.h  $ */
